import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["leftAddon", "rightAddon"];
import PropTypes from 'prop-types';
import { BASE_CLASS_ADDON_WRAPPER, ADDON_TYPES, getClassName } from './config';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var withAddons = function withAddons(WrappedInput) {
  var Addon = function Addon(_ref) {
    var leftAddon = _ref.leftAddon,
        rightAddon = _ref.rightAddon,
        props = _objectWithoutPropertiesLoose(_ref, _excluded);

    return leftAddon || rightAddon ? /*#__PURE__*/_jsxs("div", {
      className: BASE_CLASS_ADDON_WRAPPER,
      children: [leftAddon && /*#__PURE__*/_jsx("span", {
        className: getClassName({
          type: ADDON_TYPES.LEFT
        }),
        children: leftAddon
      }), /*#__PURE__*/_jsx(WrappedInput, _extends({}, props)), rightAddon && /*#__PURE__*/_jsx("span", {
        className: getClassName({
          type: ADDON_TYPES.RIGHT
        }),
        children: rightAddon
      })]
    }) : /*#__PURE__*/_jsx(WrappedInput, _extends({}, props));
  };

  return Addon;
};

export default withAddons;