import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["leftIcon", "rightIcon", "onClickLeftIcon", "onClickRightIcon"];
import PropTypes from 'prop-types';
import cx from 'classnames';
import { BASE_CLASS_ICON, BASE_CLASS_ICON_LEFT, BASE_CLASS_ICON_RIGHT, BASE_CLASS_ICON_COMPONENT, BASE_CLASS_ICON_COMPONENT_HANDLER, BASE_CLASS_ICON_COMPONENT_LEFT, BASE_CLASS_ICON_COMPONENT_RIGHT } from './config';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var withIcons = function withIcons(WrappedInput) {
  var Icon = function Icon(_ref) {
    var _cx, _cx2, _cx3;

    var leftIcon = _ref.leftIcon,
        rightIcon = _ref.rightIcon,
        onClickLeftIcon = _ref.onClickLeftIcon,
        onClickRightIcon = _ref.onClickRightIcon,
        props = _objectWithoutPropertiesLoose(_ref, _excluded);

    var handleLeftClick = function handleLeftClick(e) {
      onClickLeftIcon && onClickLeftIcon(e);
    };

    var handleRightClick = function handleRightClick(e) {
      onClickRightIcon && onClickRightIcon(e);
    };

    return leftIcon || rightIcon ? /*#__PURE__*/_jsxs("div", {
      className: cx(BASE_CLASS_ICON, (_cx = {}, _cx[BASE_CLASS_ICON_LEFT] = leftIcon, _cx[BASE_CLASS_ICON_RIGHT] = rightIcon, _cx)),
      children: [leftIcon && /*#__PURE__*/_jsx("span", {
        className: cx(BASE_CLASS_ICON_COMPONENT, BASE_CLASS_ICON_COMPONENT_LEFT, (_cx2 = {}, _cx2[BASE_CLASS_ICON_COMPONENT_HANDLER] = onClickLeftIcon, _cx2)),
        onClick: handleLeftClick,
        children: leftIcon
      }), /*#__PURE__*/_jsx(WrappedInput, _extends({}, props)), rightIcon && /*#__PURE__*/_jsx("span", {
        className: cx(BASE_CLASS_ICON_COMPONENT, BASE_CLASS_ICON_COMPONENT_RIGHT, (_cx3 = {}, _cx3[BASE_CLASS_ICON_COMPONENT_HANDLER] = onClickRightIcon, _cx3)),
        onClick: handleRightClick,
        children: rightIcon
      })]
    }) : /*#__PURE__*/_jsx(WrappedInput, _extends({}, props));
  };

  return Icon;
};

export default withIcons;